#include <amxmod.inc>
#include <Vexd_Utilities>
#include <superheromod.inc>
#include <xtrafun>

// Sniper - Autoshoot

// CVARS
// sniper_level = the level Sniper is avalable... [def=9]
// sniper_autoshoot = does Sniper autoshoot? [def=1]
// sniper_mode (1|2) = mode of autoshooting: 1 is get_user_aiming method  2 is get_user_aiming and get_user_origin
// sniper_autostop (0|1) = does sniper autostop when using AWP so more accurate?  [def=0]

// If sniper_mode = 2, then the following cvars are used:
// sniper_tolerance = the minimum distance a target has to be to your mouse cursor before autoshooting [def=15]
// sniper_autotol (0|1) = auto tolerance according to preset values for sniper rifles? [def=1]

// If sniper_autotol = 1, then the following cvars are used:
// sniper_awptol = tolerance for awp [def=12]
// sniper_scouttol = tolerance for scout [def=20]
// sniper_autosnipetol = tolerance for the two auto snipers [def=25]




// VARIABLES
new gHeroName[]="Sniper"  // name of hero
new bool:gHasSniperPower[SH_MAXSLOTS+1]  // variable if hero has sniper powers
new bool:isScoped[SH_MAXSLOTS+1]  // variable if player is scoped
new distanceX,distanceY,distanceZ
new userOrigin[3]  // variable holding location of player's aim
new locationOfAlly[SH_MAXSLOTS+1],locationOfEnemy[SH_MAXSLOTS+1]=0  // variables holding allies/enemies location
new closestEnemyOrigin[3],closestAllyOrigin[3]=0  // variables holding nearest ally/enemy location
new closestEnemyId,closestAllyId=0  // variables holding nearest ally/enemy ID
new enemyCount,allyCount,enemyLeft,allyLeft=0  // variables holding stats reporting
//----------------------------------------------------------------------------------------------
public plugin_init()
{
  // Plugin Info
  register_plugin("SUPERHERO Sniper","2.0","scoutPractice")

  // FIRE THE EVENT TO CREATE THIS SUPERHERO!
  if ( isDebugOn() ) server_print("Attempting to create Sniper Hero")
  register_cvar("sniper_level", "6" )
  shCreateHero(gHeroName, "Sniper Reflexes", "Fast Reflexes with sniper rifles!", false, "sniper_level" )

  // REGISTER EVENTS THIS HERO WILL RESPOND TO! (AND SERVER COMMANDS)
  // INIT
  register_srvcmd("sniper_init", "sniper_init")
  shRegHeroInit(gHeroName, "sniper_init")
  
  // ROUND RESET
  register_event("ResetHUD","newRound","b")
    
  // DEFAULT THE CVARS
  register_cvar("sniper_tolerance","15")
  register_cvar("sniper_autoshoot","1")
  register_cvar("sniper_autotol","1")
  register_cvar("sniper_awptol","15")
  register_cvar("sniper_scouttol","20")
  register_cvar("sniper_autosnipetol","25")
  register_cvar("sniper_mode","1")
  register_cvar("sniper_autostop","0")
}
//----------------------------------------------------------------------------------------------
public sniper_init()
{
  new temp[6]
  // First Argument is an id
  read_argv(1,temp,5)
  new id=str_to_num(temp)

  // 2nd Argument is 0 or 1 depending on whether the id has sniper
  read_argv(2,temp,5)
  new hasPowers=str_to_num(temp)

  gHasSniperPower[id]=(hasPowers!=0)
  isScoped[id]=false
  
  if (get_cvar_num("sniper_mode")==1) {
    new message[128]
    format(message,127,"Using Aiming Mode 1")
    set_hudmessage(0,0,255,-1.0,0.9,0,0.25,1.0,0.0,0.0,4)
    show_hudmessage(id,message)
  }
  if (get_cvar_num("sniper_mode")==0) {
    new message[128]
    format(message,127,"Using Aiming Mode 2")
    set_hudmessage(0,0,255,-1.0,0.9,0,0.25,1.0,0.0,0.0,4)
    show_hudmessage(id,message)
  }
  
  if (gHasSniperPower[id]) {
    set_task(0.1,"sniper_aim",0,"",0,"b")
    set_task(0.1,"find_closest_enemy",0,"",0,"b")
    set_task(0.1,"find_closest_ally",0,"",0,"b")
    set_task(6.0,"display_info",0,"",0,"b")
  }
  else {
    remove_task(id)
    remove_task(id)
    remove_task(id)
    remove_task(id)
  }
}
//----------------------------------------------------------------------------------------------
public newRound(id)
{
  if ( gHasSniperPower[id] && is_user_alive(id) )
  {
    isScoped[id]=false
    new message[128]
    format(message,127,"Fast Reflexes... Just aim your cursor at the enemy",2.0)
    set_hudmessage(255,0,0,-1.0,1.0,0,1.0,1.0,0.0,0.0,4)
    show_hudmessage(id, message)
  }

  return PLUGIN_CONTINUE;
}
//----------------------------------------------------------------------------------------------
public checkScoped(id) {
  if (is_user_alive(id) && gHasSniperPower[id]) {
    if (get_user_button(id)&IN_ATTACK2) {
      isScoped[id]=true
      client_print(id,print_center,"Player is SCOPED")
      return PLUGIN_HANDLED
    }
    if (get_user_button(id)&IN_ALT1) {
      isScoped[id]=true
      client_print(id,print_center,"Player is SCOPED")
      return PLUGIN_HANDLED
    }
    if (get_user_button(id)&IN_RELOAD) {
      isScoped[id]=false
      client_print(id,print_center,"Player is NOT SCOPED")
      return PLUGIN_HANDLED
    }
    if (get_user_button(id)&IN_ATTACK) {
      isScoped[id]=true
      client_print(id,print_center,"Player is SCOPED")
      return PLUGIN_HANDLED
    }
    new temp,temp1
    new weapId=get_user_weapon(id,temp,temp1)
    if (weapId!=CSW_G3SG1 && weapId!=CSW_SG550 && weapId!=CSW_AWP && weapId!=CSW_SCOUT) {
      isScoped[id]=false
      client_print(id,print_center,"Player is NOT SCOPED")
      return PLUGIN_HANDLED
    }
  }
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public sniper_aim() {
  for (new id=1;id<=get_maxplayers(); id++) {
    if (is_user_alive(id) && gHasSniperPower[id]) { 
      get_user_origin(id,userOrigin,3)  // LOCATION OF USER'S MOUSE CURSOR
      
      new velocity[3]
      get_user_velocity(id, velocity)
      if ( velocity[2] < -10 || velocity[2] > 10 ) return PLUGIN_HANDLED
      
      if (get_cvar_num("sniper_autostop")!=1 && get_cvar_num("sniper_autostop")!=0) {
        set_cvar_num("sniper_autostop",0)
      }
      if (get_cvar_num("sniper_autotol")!=1 && get_cvar_num("sniper_autotol")!=0) {
        set_cvar_num("sniper_autotol",1)
      }
      if (get_cvar_num("sniper_mode")!=1 && get_cvar_num("sniper_mode")!=2) {
        set_cvar_num("sniper_mode",1)
      }
      checkScoped(id)
      
      new temp,temp1
      new weaponId=get_user_weapon(id,temp,temp1)
      if (weaponId==CSW_G3SG1 || weaponId==CSW_SG550 || weaponId==CSW_AWP || weaponId==CSW_SCOUT) {
        if (isScoped[id]) {
          if (get_cvar_num("sniper_autoshoot")==1) {
            if (get_cvar_num("sniper_mode")==1) {  // get_user_aiming method
              new aid,abody
              new team1[32],team2[32] 
              get_user_aiming(id,aid,abody) 
              if (aid) {
                if (get_user_team(id,team1,31)==get_user_team(aid,team2,31)) return PLUGIN_HANDLED
                new enemyName[32]
                get_user_name(closestEnemyId,enemyName,31)
                new enemyHP=get_user_health(closestEnemyId)
                client_print(id,print_center,"LOCKED: %s with %d HP",enemyName,enemyHP)
                if (abody!=4 && abody!=5) sniper_autosnipe(id)
              }
            }
            if (get_cvar_num("sniper_mode")==2) {  // get_user_origin method coupled with get_user_aiming method
              distanceX=userOrigin[0]-closestEnemyOrigin[0]
              distanceY=userOrigin[1]-closestEnemyOrigin[1]
              distanceZ=userOrigin[2]-closestEnemyOrigin[2]
              if (distanceX<0) distanceX=(distanceX * -1)
              if (distanceY<0) distanceY=(distanceY * -1)
              if (distanceZ<0) distanceZ=(distanceZ * -1)
              new sniperTolerance=get_cvar_num("sniper_tolerance")
              new aid,abody
              new team1[32],team2[32] 
              get_user_aiming(id,aid,abody)
              if (aid) {
                if (get_user_team(id,team1,31)==get_user_team(aid,team2,31)) return PLUGIN_HANDLED
                new enemyName[32]
                get_user_name(closestEnemyId,enemyName,31)
                new enemyHP=get_user_health(closestEnemyId)
                client_print(id,print_center,"LOCKED: %s with %d HP",enemyName,enemyHP)
                if (abody!=4 && abody!=5) sniper_autosnipe(id)
              }
              if (distanceX<=sniperTolerance && distanceY<=sniperTolerance && distanceZ<=(sniperTolerance+25)) {
                new enemyName[32]
                get_user_name(closestEnemyId,enemyName,31)
                new enemyHP=get_user_health(closestEnemyId)
                client_print(id,print_center,"LOCKED: %s with %d HP",enemyName,enemyHP)
                sniper_autosnipe(id)
              } 
            }
          }
        }
      }
    }
  }
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public get_info(id) {
  for (new playerid=1;playerid<=get_maxplayers();playerid++) {
    if (is_user_alive(playerid) && playerid!=id && get_user_team(id)!=get_user_team(playerid)) {
      new enemyLocation[3], me[3]
      get_user_origin(playerid,enemyLocation)
      get_user_origin(id,me)
      new checkDistance=get_distance(me,enemyLocation)
      if (checkDistance<=800) {
        enemyCount+=1
      }
      enemyLeft+=1
    }
    if (is_user_alive(playerid) && playerid!=id && get_user_team(id)==get_user_team(playerid)) {
      new allyLocation[3], me[3]
      get_user_origin(playerid,allyLocation)
      get_user_origin(id,me)
      new checkDistance=get_distance(me,allyLocation)
      if (checkDistance<=800) {
        allyCount+=1
      }
      allyLeft+=1
    }
  }
  return PLUGIN_HANDLED
}
public display_info() {
  for (new id=1;id<=get_maxplayers();id++) {
    get_info(id)
    new enName[32], alName[32]
    get_user_name(closestEnemyId,enName,31)
    get_user_name(closestAllyId,alName,31)
    new enHP=get_user_health(closestEnemyId)
    new alHP=get_user_health(closestAllyId)
    new myorigin[3]
    get_user_origin(id,myorigin)
    new enDistance=get_distance(myorigin,closestEnemyOrigin)
    new alDistance=get_distance(myorigin,closestAllyOrigin)
    new mess[512]
    new len = format(mess,511,"")
    if (enemyLeft!=0 && enemyLeft!=-1) {
      len += format(mess[len],511-len,"There are still %d enemies ",enemyLeft)
    }
    if (allyLeft!=0 && allyLeft!=-1) {
      if (enemyLeft!=0 && enemyLeft!=-1) {
        len += format(mess[len],511-len,"and %d allies left",allyLeft)
      }
      if (enemyLeft==0 || enemyLeft==-1) {
        len += format(mess[len],511-len,"There are no enemies left!")
      }
    }
    if (enemyCount!=0 && enemyCount!=-1) {
      len += format(mess[len],511-len,"^nBeware... There are %d enemies ",enemyCount)
    }
    if (allyCount!=0 && allyCount!=-1) {
      if (enemyCount!=0 && enemyCount!=-1) {
        len += format(mess[len],511-len,"and %d allies nearby^n",allyCount)
      }
      if (enemyCount==0 || enemyCount==-1) {
        len += format(mess[len],511-len,"^nThere are %d allies nearby^n",allyCount)
      }
    }
    if (closestEnemyId!=0 && closestEnemyId!=-1 && enHP>=1) {
      len += format(mess[len],511-len,"^nClosest Enemy is %s with %d HP at %i feet away from you",enName,enHP,enDistance) 
    }
    if (closestAllyId!=0 && closestAllyId!=-1 && alHP>=1) {
      len += format(mess[len],511-len,"^nClosest Ally is %s with %d HP at %i feet away from you",alName,alHP,alDistance)
    }
    if (closestAllyId==0 || closestAllyId==-1 || alHP<=0) {
      len += format(mess[len],511-len,"^nYou are alone now!")
    }
    set_hudmessage(0,128,0,-1.0,0.75,0,1.0,3.0,0.0,0.0,4)
    show_hudmessage(id,mess)
    if (enemyCount!=0 || allyCount!= 0) {
      enemyCount=0
      allyCount=0
    }
    if (allyLeft!=0 || enemyLeft!=0) {
      allyLeft=0
      enemyLeft=0
    }
  }
}
//----------------------------------------------------------------------------------------------
public find_closest_enemy() {
for (new id=1;id<=SH_MAXSLOTS;id++) {
  for (new playerid = 1; playerid <= SH_MAXSLOTS; playerid++) {
    if (is_user_alive(playerid) && playerid!=id && get_user_team(id)!=get_user_team(playerid)) {
      new location[3]
      new me[3]
      get_user_origin(id,me)
      locationOfEnemy[playerid]=get_distance(me,location)
//      console_print(id,"Player with valid id %i is found",playerid) // debugging purposes
    }
    if (!is_user_alive(playerid) || playerid==id || get_user_team(id)==get_user_team(playerid)) {
      locationOfEnemy[playerid]=-1
//      console_print(id,"Player with id %i is invalid and set to -1",playerid)  // debugging purposes
    }
  }
  for (new int=1;int<=SH_MAXSLOTS;int++) {
    if (locationOfEnemy[int]<locationOfEnemy[int+1]) {
      if (is_user_connected(int)) {
        if (is_user_connected(int+1)) {
          if (locationOfEnemy[int]>=0) {
            closestEnemyId=int
//            console_print(id,"Player with id %i is found",int)  // debugging purposes
          }
          else {
            if (locationOfEnemy[int+1]>=0) {
              closestEnemyId=(int+1)
//              console_print(id,"Player with id %i is invalid so player with id %i is used",int,int+1)  // debugging purposes
            }
          }
        }
        else { 
          if (locationOfEnemy[int]>=0) {
            closestEnemyId=int 
          }
        }
      }
      if (!is_user_connected(int) && is_user_connected(int+1)) { 
        if (locationOfEnemy[int+1]>=0) {
          closestEnemyId=(int+1) 
        }
      }        
    }
    else {
      if (is_user_connected(int)) {
        if (is_user_connected(int+1)) {
          if (locationOfEnemy[int+1]>=0) {
            closestEnemyId=(int+1)
//            console_print(id,"Player with id %i is found",int+1)  // debugging purposes
          }
          else {
            if (locationOfEnemy[int]>=0) {
              closestEnemyId=int
//              console_print(id,"Player with id %i is invalid so player with id %i is used",int+1,int)  // debugging purposes
            }
          }
        }
        else {
          if (locationOfEnemy[int]>=0) {
            closestEnemyId=int
          }
        }
      }
      if (!is_user_connected(int) && is_user_connected(int+1)) {
        if (locationOfEnemy[int+1]>=0) {
          closestEnemyId=(int+1)
        }
      }
    }
  }
  if (closestEnemyId!=-1 && closestEnemyId!=0) {
    get_user_origin(closestEnemyId,closestEnemyOrigin)
  }
  if (closestEnemyId==-1 || closestEnemyId==0) {
    closestEnemyOrigin[0]=-1
    closestEnemyOrigin[1]=-1
    closestEnemyOrigin[2]=-1
  }
  return PLUGIN_HANDLED
}
return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public find_closest_ally() {
for (new id=1;id<=SH_MAXSLOTS;id++) {
  for (new playerid = 1; playerid <= SH_MAXSLOTS; playerid++) {
    if (is_user_alive(playerid) && playerid!=id && get_user_team(id)==get_user_team(playerid)) {
      new location[3]
      new me[3]
      get_user_origin(id,me)
      locationOfAlly[playerid]=get_distance(me,location)
//      console_print(id,"Player with valid id %i is found",playerid) // debugging purposes
    }
    if (is_user_alive(playerid) && playerid==id) {
      locationOfAlly[playerid]=-1
    }
    if (!is_user_alive(playerid) || get_user_team(id)!=get_user_team(playerid)) {
      locationOfAlly[playerid]=-1
//      console_print(id,"Player with id %i is invalid and set to -1",playerid)  // debugging purposes
    }
  }
  for (new int=1;int<=SH_MAXSLOTS;int++) {
    if (locationOfAlly[int]<locationOfAlly[int+1]) { 
      if (is_user_connected(int)) {
        if (is_user_connected(int+1)) { 
          if (locationOfAlly[int]>=0) {
            closestAllyId=int
//            console_print(id,"Player with id %i is found",int)  // debugging purposes
          }
          else { 
            if (locationOfAlly[int+1]>=0) {
              closestAllyId=(int+1) 
//              console_print(id,"Player with id %i is invalid so player with id %i is used",int,int+1)  // debugging purposes
            }
          }
        }
        else {
          if (locationOfAlly[int]>=0) {
            closestAllyId=int
          }
        }
      }
      if (!is_user_connected(int) && is_user_connected(int+1)) {
        if (locationOfAlly[int+1]>=0) {
          closestAllyId=(int+1)
        }
      }        
    }
    else { 
      if (is_user_connected(int)) { 
        if (is_user_connected(int+1)) {
          if (locationOfAlly[int+1]>=0) {
            closestAllyId=(int+1)
//            console_print(id,"Player with id %i is found",int+1)  // debugging purposes
          }
          else {
            if (locationOfAlly[int]>=0) {
              closestAllyId=int 
//              console_print(id,"Player with id %i is invalid so player with id %i is used",int+1,int)  // debugging purposes
            }
          }
        }
        else { 
          if (locationOfAlly[int]>=0) {
            closestAllyId=int
          }
        }
      }
      if (!is_user_connected(int) && is_user_connected(int+1)) {
        if (locationOfAlly[int+1]>=0) {
          closestAllyId=(int+1)
        }
      }
    }
  }
  if (closestAllyId!=-1 && closestAllyId!=0) {
    get_user_origin(closestAllyId,closestAllyOrigin)
  }
  if (closestAllyId==-1 || closestAllyId==0) {
    closestAllyOrigin[0]=-1
    closestAllyOrigin[1]=-1
    closestAllyOrigin[2]=-1
  }
  return PLUGIN_HANDLED
}
return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
public sniper_autosnipe(id) {
  if (get_cvar_num("sniper_autoshoot")==1) {
    if (get_cvar_num("sniper_mode")==2) {
      new sniperTolerance
      if (get_cvar_num("sniper_autotol")!=1) sniperTolerance=get_cvar_num("sniper_tolerance")
      if (get_cvar_num("sniper_autotol")==1) {
        new temp,temp1
        new weapon=get_user_weapon(id,temp,temp1)
        if (weapon==CSW_G3SG1 || weapon==CSW_SG550) sniperTolerance=get_cvar_num("sniper_autosnipetol")
        if (weapon==CSW_AWP) sniperTolerance=get_cvar_num("sniper_awptol")
        if (weapon==CSW_SCOUT) sniperTolerance=get_cvar_num("sniper_scouttol")
      }
      if (distanceX<=(sniperTolerance+2) && distanceY<=(sniperTolerance+2) && distanceZ<=(sniperTolerance+15)) {
      // AUTO SNIPE if sniper_mode = 2 and if enemy is close enough
      new temp,temp1
      new weapon=get_user_weapon(id,temp,temp1)
      if (weapon==CSW_AWP) {
        if (get_cvar_num("sniper_autostop")==1) {
          if (get_user_button(id)&IN_MOVELEFT || get_user_button(id)&IN_MOVERIGHT || get_user_button(id)&IN_BACK || get_user_button(id)&IN_FORWARD) { 
            client_cmd(id,"-moveleft")  // stop player from moving
            client_cmd(id,"-moveright")  // because awp is inaccurate while moving
            client_cmd(id,"wait")  // provde an extra wait when shooting with awp...
          }
        }
        client_cmd(id,"wait")  // provide an extra wait when shooting with awp...
      }
      if (weapon==CSW_G3SG1 || weapon==CSW_SG550) {
        client_cmd(id,"wait")  // provide a wait when shooting with GSG or SIG550
      }
      client_cmd(id,"+attack")
      client_cmd(id,"wait")
      client_cmd(id,"-attack")
      client_cmd(id,"wait")
      }
    }
    if (get_cvar_num("sniper_mode")==1) {
    // AUTO SNIPE if sniper_mode = 1
      new temp,temp1
      new weapon=get_user_weapon(id,temp,temp1)
      if (weapon==CSW_AWP) {
        if (get_cvar_num("sniper_autostop")==1) {
          if (get_user_button(id)&IN_MOVELEFT || get_user_button(id)&IN_MOVERIGHT || get_user_button(id)&IN_BACK || get_user_button(id)&IN_FORWARD) { 
            client_cmd(id,"-moveleft")  // stop player from moving
            client_cmd(id,"-moveright")  // because awp is inaccurate while moving
            client_cmd(id,"wait")  // provide an extra wait when shooting with awp...
          }
        }
        client_cmd(id,"wait")  // provide an extra wait when shooting with awp...
      }
      if (weapon==CSW_G3SG1 || weapon==CSW_SG550) {
        if (get_user_button(id)&IN_MOVELEFT || get_user_button(id)&IN_MOVERIGHT || get_user_button(id)&IN_BACK || get_user_button(id)&IN_FORWARD) { 
          client_cmd(id,"wait")  // provide a wait when shooting with GSG or SIG550
        }
      }
      client_cmd(id,"+attack")
      client_cmd(id,"wait")
      client_cmd(id,"-attack")
      client_cmd(id,"wait")
    }
    return PLUGIN_HANDLED
  }
  return PLUGIN_HANDLED
}
//----------------------------------------------------------------------------------------------
  
//----------------------------------------------------------------------------------------------
public client_disconnect(id)
{
  // stupid check but lets see
  if ( id <=0 || id>32 ) return PLUGIN_CONTINUE

  // Yeah don't want any left over residuals
  remove_task(id)
  remove_task(id)
  remove_task(id)
  remove_task(id)
  remove_task(id)
  
  return PLUGIN_CONTINUE  
}
//----------------------------------------------------------------------------------------------
